找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 879|回复: 0

[分享] Creating 3D Solids programmatically

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-7 01:16:41 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Geometry;
using Autodesk.AutoCAD.Runtime;

namespace ExtrudedSolidSample
{
    public class Commands
    {
        [CommandMethod("Test")]
        public void Test()
        {
            Database db = HostApplicationServices.WorkingDatabase;
            using (Transaction tr = db.TransactionManager.StartTransaction())
            {
                // Create a closed polyline (it have to be disposed because it won't be added to the database)
                using (Polyline pline = new Polyline(12))
                {
                    pline.AddVertexAt(0, new Point2d(100.0, 100.0), 0.0, 0.0, 0.0);
                    pline.AddVertexAt(0, new Point2d(200.0, 100.0), 0.0, 0.0, 0.0);
                    pline.AddVertexAt(0, new Point2d(200.0, 130.0), 0.0, 0.0, 0.0);
                    pline.AddVertexAt(0, new Point2d(180.0, 130.0), 0.0, 0.0, 0.0);
                    pline.AddVertexAt(0, new Point2d(180.0, 170.0), 0.0, 0.0, 0.0);
                    pline.AddVertexAt(0, new Point2d(200.0, 170.0), 0.0, 0.0, 0.0);
                    pline.AddVertexAt(0, new Point2d(200.0, 200.0), 0.0, 0.0, 0.0);
                    pline.AddVertexAt(0, new Point2d(100.0, 200.0), 0.0, 0.0, 0.0);
                    pline.AddVertexAt(0, new Point2d(100.0, 170.0), 0.0, 0.0, 0.0);
                    pline.AddVertexAt(0, new Point2d(120.0, 170.0), 0.0, 0.0, 0.0);
                    pline.AddVertexAt(0, new Point2d(120.0, 130.0), 0.0, 0.0, 0.0);
                    pline.AddVertexAt(0, new Point2d(100.0, 130.0), 0.0, 0.0, 0.0);
                    pline.Closed = true;
                    DBObjectCollection curves = new DBObjectCollection { pline };

                    // Create a region (it have to be disposed because it won't be added to the database)
                    using(DBObjectCollection regions = Region.CreateFromCurves(curves))
                    {
                        // Create a solid 3d (it will be added to the database)
                        Solid3d solid = new Solid3d();
                        solid.Extrude((Region)regions[0], 500.0, 0.0);
                        BlockTable bt = (BlockTable)tr.GetObject(db.BlockTableId, OpenMode.ForRead);
                        BlockTableRecord btr =
                            (BlockTableRecord)tr.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForWrite);
                        btr.AppendEntity(solid);
                        tr.AddNewlyCreatedDBObject(solid, true);
                        
                        // Create a slicing plane
                        Plane plane = new Plane(new Point3d(200.0, 200.0, 500.0), new Vector3d(0.0, 1.0, -1.0));

                        // Slice the solid 3d with the plane
                        solid.Slice(plane, true);
                    }
                }
                tr.Commit();
            }
        }
    }
}
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-5-23 02:08 , Processed in 0.341441 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表